# Chapter7.py

# DataSet / Collections Class Review

# List [brackets] ['Bob'[0],'Joe'[1],'Mary'[2]] 
## change/rw/mutate element1"Bob">"Robert"
## indexed len(3) range[0:2]  fname[1] 'Joe'
## duplicates ok ['Betty','Mark','Betty']
## singular 'Betty'
## sort().reverse > characters  Mary,Joe,Bob   
## range().dsc > 2,1,0 indexed

# Set {braces} items  {'Bob','Mary','Joe'}
## immutable, add to a set
## NOT indexed len(3) NO Identifier
## NO Duplicates input data > Bob,Joe,Mary,Bob,Mark,Joe {'Bob','Joe','Mary','Mark'}
## No sort order {'Bob','Joe','Mary','Mark'}.sort()  {'Joe','Mary','Bob','Mark'} ...
## fast
## singular

# Tuple (round backets) params ('Bob'(p1),'Joe'(p2),'Mary'(p3))
## Secure > immutable / !add  job(tuple)
## duplicates ('Bob','Joe','Mary','Mark','Bob')
## ranged (positional arg start with 1 not 0) left to right  arg1, arg2 > param1, param2
## singular !sorted

# Dictionary Class (High) Map Collection (Lower)
## 'key': value   'firstname': 'Bob' 'age': 52 'vipStatus': True
## {Set} key UNIQUE value DUP { 'firstname': 'Bob', 'age': 52, 'vipStatus': True, 'orderstatus': True }
## key IMMUTABLE value MUTABLE  'firstname': 'Bob' > 'firstname': 'Robert'

# Array import pandas
# pandas dataframes
# NOT singular or key:value BUT row/col
# 1 DIM array col(Series)  y
# 2 DIM array row/col x,y
# 3 DIM array p1 > row/col  >> PIVOT TABLE  z > x,y
# 4 DIM array p2,p1 > row/col  a,z > x,y
# DIMENSIONS > 7 DIM  p5<7DIM>,p4,p3,p3,p1 > row/col

# Pythonic Principle > Framework<MVC> / Resource Allocation / Readability

# Variables
## Python
x = 7
y = 3
z = 8

## Pythonic
x,y,z = 7,3,8
fname, lname, age = "Bob","Smith",52

# List Comprehension Page 82
## Python
l = [] # empty list in memory
# append() to assign values to the list
for x in range(10):
    l.append(x)
    x += 1
print(l)

## Pythonic
# Create the list, append all elements 0-9, store it memory
lc = [ 
    # param control indexer
    x + 1 
    # param loop
    for x in range(10) ] # [0,1,2,3,4,5,6,7,8,9] >>>> memory
print(lc)

# Dictionary Comprehension page 84
## key 'fname'  value 'Bob  [ { 'fname': 'Bob', 'lname':'Smith' } , {'fname': 'Joe' } ]
names = ['Bob','Mary','Betty','Bob']
## Python
fname_values = []
for name in names:
    fname_name = { 'fname': name }
    fname_values.append(fname_name)  #  list.append(dict)
print(fname_values) # outputted appended list of dict entries
# [{'fname': 'Bob'}, {'fname': 'Mary'}, {'fname': 'Betty'}, {'fname': 'Bob'}]

## Pythonic
fname_values_pythonic = [
    # param control
    { 'fname': name }
    # param loop
    for name in names
]
print(fname_values_pythonic) # [{'fname': 'Bob'}, {'fname': 'Mary'}, {'fname': 'Betty'}, {'fname': 'Bob'}]

# Interators Page 85
## Lists
### Lists using .append()  Python List
### Lists using comprehension Pythonic List Comprehension
### Lists using attributes in Python  __init__
### Lists using Iterators Pythonic __init__ with __next__

## Python Lists using attributes in Python  __init__
class NonPythonicIterable:
    def __init__(self, max):
        self.max = max # attr<10> = param max = arg 10 <passed>
    
    # iterator page 85
    def iterate(self): # instance method access to max attr
        num = 0 # control variable
        # condition
        while num < self.max: 
            yield num
            num += 1

# create an instance of the class, expect 1 arg <max>
iterator = NonPythonicIterable(10)
# test it with a for loop
for num in iterator.iterate():
    print(num)

# Pythonic > replace the iterate(self) "iterator and loop" with __iter__(iterator)  and __next__(loop)

class PythonicIterable:
    def __init__(self, max):
        self.max = max
        # control
        self.num = 0 # moved the local variable from an instance method<iterate()> to an attr

    # def iterate(self) replace it with __iter__
    def __iter__(self): # max attr
        return self # iteration from 0 to max(10)

    def __next__(self): # max attr
        # replace the while statment in the instance method<iterate()> with an if keyword
        if self.num < self.max:
            num = self.num # replaces yield num
            self.num += 1 # increment
            return num
        raise StopIteration # replace else: break

# Application
range_num = int(input("Enter a range stop int:"))
iterator_pythonic = PythonicIterable(range_num)
for n in iterator_pythonic:  # in iterator.iterate() replace with __attr__<iter next>
    print(n)




